package test;

import com.mysql.jdbc.ProfilerEventHandlerFactory;

import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Map;

public class Main {
    public static void main(String[] args) {
        int count = 0;
        Map ctsObject = null;

        try {
            Field ctsField = ProfilerEventHandlerFactory.class.getDeclaredField("CONNECTIONS_TO_SINKS");
            ctsField.setAccessible(true);
            ctsObject = (Map)ctsField.get(null);
        } catch (Throwable e) {
            e.printStackTrace();
        }

        for (int j = 0; j < 1000; j++) {
            for (int i = 0; i< 1000; i++) {
                try {
                    Connection con = DriverManager.getConnection("jdbc:mysql://localhost:3333?profileSQL=true&user=test&password=123");
                    con.close();
                } catch (SQLException e) {
                    count ++;
                } catch (OutOfMemoryError e) {
                    System.out.println("Out of memory on = " + count + ", connections to sinks size = " +
                            (ctsObject != null ? ctsObject.size() : "unknown, use break point here."));
                }
            }

            System.out.println("Dead connections count = " + count);
        }
    }
}
